{# This means your page inherit from an existing template, it will already contains some html and allow to override what's inside the "blocks" #}
{% extends 'base.html.twig' %}

{% trans_default_domain 'Battle' %}

{% block stylesheets %}
    {# Any extra CSS for your page #}
{% endblock %}

{% block javascripts %}
    <script type="text/javascript" src="{{ asset('js/battle.js') }}"></script>
    <script>
        let serverData = {{ battleData | raw }};
        let estimatedBattleEndDate = new Date("{{ estimatedBattleEndDate }}");
    </script>
{% endblock %}

{% block title %}{{ 'tabHeader' | trans }}{% endblock %}

{#
Sur la page de la bataille les attaquants se situent à gauche et les défenseurs à droite.

Un combat se déroule par l'intermédiaire de duels simultanés. Un duel se déroule de la sorte : une unité inactive de chaque camp est sélectionnée aléatoirement.
Les deux unités sélectionnées entrent en duel. Elles s'infligeront des dégâts jusqu'à ce qu'une des deux unités meurt.
L'unité encore en vie redevient alors inactive mais ne récupère pas ses points de vie perdus.
Un autre duel peut ensuite commencer, reprenant éventuellement l'unité qui vient d'en sortir comme combattant.
Un combat ne peut prendre fin que par la mort (aucune unitée restante, fuite, faillite, transformation?) d'un des deux camps ou par fin prématurée du combat (via vassalisation, mort d'un joueur).

On ne peut pas engager des troupes des deux côtés à la fois. Même si un vassal ne peut pas attaquer un territoire de son suzerain
il peut attaquer un territoire défendu par son suzerain ou défendre un territoire attaqué par son suzerain.

Plusieurs joueurs peuvent s'associer en attaque comme en défense.
Pendant qu'une bataille est engagée on ne peut ni récupérer des troupes sur la garnison ni en déposer mais deux généraux du même joueur peuvent échanger des troupes sur le lieu de la bataille.

Lorsqu'un combattant n'a plus aucune unité en vie, il est déclaré perdant. Les unités restantes du gagnant récupèrent tous leurs points de vie si elles avaient été blessées au cours de la bataille.
Il est important de noter que toutes les unités ne sont pas égales au cours des duels car certains types d'unités ont des bonus contre d'autres.
Il est possible de consulter l'état de santé des unités d'une armée en cliquant sur les petits drapeaux de chaque armée. Un résumé sous forme de tableau des unités de l'armée sélectionnée s'affiche alors.
En laissant le curseur sur le nombre d'unités de chaque type blessées, on peut faire apparaître la moyenne des points de vie restants des unités blessées.
#}

{% set isFinished = battle.finished %}

{% block content %}
    <table class="maptable">
        <tbody>
        <tr>
            <td class="frame">
                <div class="home_frame">
                    <h1>{{ 'header.battle' | trans({'%location%': battle.location.name }) }}</h1>

                    <img id="battle_background" src="{{ asset('img/battle/background.png') }}"/>
                    <canvas id="battle_canvas">
                    </canvas>
                </div>
            </td>
            <td class="right">
                <div class="box3">
                    <div class="box3bottom">
                        <div class="box3bg">
                            <h2 class="h2f">{{ 'actions.title' | trans }} : </h2>
                            {% if isFinished %}
                                <p class="nothing">
                                    {{ 'state.finished' | trans }}.
                                </p>
                            {% else %}
                                <div class="pbattle">
                                    {{ 'state.ongoing' | trans }} :

                                    <script type="text/javascript">
                                        mt.js.Timer.TIMES="jhms";
                                        mt.js.Timer.alloc(formatDate(new Date()), formatDate(estimatedBattleEndDate), 3, null);
                                    </script>
                                </div>
                            {% endif %}

                            <ul class="actions actionsbig">
                                {% if not battle.finished %}
                                    {% set lostCount = 'TODO' %}

                                    {# TODO Flee action! #}
                                    {#
                                    <li onmouseover="showHint(this,'{{ 'actions.flee.tooltip.title' | trans }}',
                                            '{{ 'actions.flee.tooltip.message' | trans({'%generalName%': 'TODO', '%lostCount%': lostCount}) }}')"
                                        onmouseout="hideHint()">
                                        <script type="text/javascript">
                                            function leave() {
                                                if( confirm('{{ 'actions.flee.confirm' | trans({'%lostCount%': lostCount}) }}') )
                                                    document.location = '/battle/id/flee/generalId';
                                            }
                                        </script>

                                        <div onclick="leave()">
                                            <img src="{{ asset('img/icons/a_run.png') }}">
                                            <span>{{ 'actions.flee.button' | trans }}</span>
                                        </div>
                                    </li>
                                    #}

                                    {# TODO Recruit allies! #}
                                    {#
                                    <li>
                                        <script type="text/javascript">
                                            function allies(id,n) {
                                                if( confirm('{{ 'actions.recruitAllies.confirm' | trans }}') )
                                                    document.location = '/battle/3211395/allies?g=1513962;id='+id;
                                            }
                                        </script>

                                        <div onclick="allies(11458337,2)">
                                            <img src="{{ asset('img/icons/a_ally.png') }}">
                                            <span>{{ 'actions.recruitAllies.button' | trans }}</span>
                                        </div>
                                    </li>
                                    #}

                                    <li>
                                        <div>
                                            <a href="{{ path('app_battle_refreshbattle', {'id': battle.id}) }}">
                                                <img src="{{ asset('img/icons/a_turns.png') }}">
                                                <span>{{ 'actions.refresh' | trans }}</span>
                                            </a>
                                        </div>
                                    </li>
                                {% endif %}

                                <li>
                                    <div onclick="document.location = '{{ path('app_map_focusNode', {'worldId' : battle.location.owningWorld.id, 'nodeId': battle.location.id}) }}'">
                                        <img src="{{ asset('img/icons/a_map.png') }}">
                                        <span>{{ 'actions.goToMap' | trans }}</span>
                                    </div>
                                </li>
                            </ul>

                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
                <script type="text/javascript">
                    // TODO Function to show an Army on click!
                    function showCamp(id) {
                    }
                </script>

                {# Battle info #}

                <div id="attackingArmies">
                {% for engagedArmy in battle.attackingArmies %}
                    {% set army = engagedArmy.armyContainer %}
                    {% set armyString = '' %}
                    {% set unitsToDisplay = ['soldier', 'pikeman', 'archer', 'horseman', 'knight', 'mountedArcher', 'paladin', 'catapult', 'ballista'] %}
                    {% for unit in unitsToDisplay %}
                        {% set armyString = armyString ~ army.getUnitCount(unit) %}
                        {% if loop.last == false %}
                            {% set armyString = armyString ~ ',' %}
                        {% endif %}
                    {% endfor %}

                    {# TODO Only display the statistics when interacting with the flag! #}
                    <div class="box3" id="{{ army.id }}" data-army="{{ armyString }}" data-is_defending="false" {% if not isFinished %}style="display: block"{% endif %}>
                        <div class="box3bottom">
                            <div class="box3bg">
                                <h2 class="h2f">{{ "side.attacking" | trans }} [ID: {{ army.id }}]</h2>
                                {% for general in battle.engagedGenerals %}
                                    {% if engagedArmy.linkedArmy is not null and general.armyContainer.id == engagedArmy.linkedArmy.id %}
                                        <p>
                                            <img src="{{ asset('img/icons/gnr_mini.gif') }}"> {{ "general" | trans([], 'Common') }} <strong>{{ general.name }} [{{ general.owner.name }}]</strong>
                                        </p>
                                    {% endif %}
                                {% endfor %}
                                {% include 'Battle/armyStats.html.twig' with {'unitStats' : engagedArmy.stats } %}
                            </div>
                        </div>
                    </div>
                {% endfor %}
                </div>

                <div id="defendingArmies">
                {% for engagedArmy in battle.defensingArmies %}
                    {% set army = engagedArmy.armyContainer %}
                    {% set armyString = '' %}
                    {% set unitsToDisplay = ['soldier', 'pikeman', 'archer', 'horseman', 'knight', 'mountedArcher', 'paladin', 'catapult', 'ballista'] %}
                    {% for unit in unitsToDisplay %}
                        {% set armyString = armyString ~ army.getUnitCount(unit) %}
                        {% if loop.last == false %}
                            {% set armyString = armyString ~ ',' %}
                        {% endif %}
                    {% endfor %}

                    <div class="box3" id="{{ army.id }}" data-army="{{ armyString }}" data-is_defending="true" {% if not isFinished %}style="display: block"{% endif %}>
                        <div class="box3bottom">
                            <div class="box3bg">
                                <h2 class="h2f">{{ "side.defending" | trans }} [ID: {{ army.id }}]</h2>
                                {% for general in battle.engagedGenerals %}
                                    {% if engagedArmy.linkedArmy is not null and general.armyContainer.id == engagedArmy.linkedArmy.id %}
                                    <p>
                                        <img src="{{ asset('img/icons/gnr_mini2.gif') }}"> {{ "general" | trans([], 'Common') }} <strong>{{ general.name }} [{{ general.owner.name }}]</strong>
                                    </p>
                                    {% endif %}
                                {% endfor %}
                                {% include 'Battle/armyStats.html.twig' with {'unitStats' : engagedArmy.stats } %}
                            </div>
                        </div>
                    </div>
                {% endfor %}
                </div>

                {% if battle.fights.count > 0 %}
                    {% include 'Battle/Fights.html.twig' with {'fights' : battle.fights } %}
                {% endif %}
            </td>
        </tr>
        </tbody>
    </table>

    {% include 'Components/LogsList.html.twig' with
        {
            'title': 'header.logs' | trans,
            'logs': logs
        }
    %}
{% endblock %}